Subject: Re: Single socket with TX_RING and RX_RING

From: Daniel Borkmann <[email-masked]>
Date: Wed, 15 May 2013 16:52:24 +0200

On 05/15/2013 04:47 PM, Daniel Borkmann wrote:
> On 05/15/2013 03:32 PM, Ricardo Tubío wrote:
>> Daniel Borkmann <dborkman <at> redhat.com> writes:
>>> On 05/15/2013 02:53 PM, Ricardo Tubío wrote:
>>>> Once I tell kernel to export the TX_RING through setsockopt() (see code
>>>> below) I always get an error (EBUSY) if i try to tell kernel to export the
>>>> RX_RING with the same socket descriptor. Therefore, I have to open an
>>>> additional socket for the RX_RING and I require of two sockets when I though
>>>> that I would only require of one socket for both TX and RX using mmap()ed
>>>> memory.
>>>>
>>>> Do I need both sockets or am I doing something wrong?
>>>
>>> The second time you call init_ring() in your code e.g. with TX_RING, where
>>> you have previously set it up for the RX_RING. The kernel will give you
>>> -EBUSY because the packet socket is already mmap(2)'ed.
>
> (if you need an answer, then please do not drop the CC, otherwise it could be
>   that I might not read it)
>
>> Ok, so if I make the following system calls:
>>
>> void *ring=NULL;
>> setsockopt(socket_fd, SOL_PACKET, PACKET_RX_RING, p, LEN__TPACKET_REQ);
>> ring = mmap(NULL, ring_len, ring_access_flags, MAP_SHARED, socket_fd, 0);
>>
>> Would I be permitted to use the ring map obtained both for RX and for TX? If
>> so, for me it is confusing to use PACKET_RX_RING if I can also TX data
>> through that ring...

No, just as a side note, I think here you rather wanted to say ...

  setsockopt(socket, SOL_PACKET, PACKET_RX_RING, ...);
  setsockopt(socket, SOL_PACKET, PACKET_TX_RING, ...);

... and then only once:

  ring = mmap(NULL, ..., socket, 0);

> I haven't tried it out yet, and currently also do not really have time to. But
> looking at the mmap code, it seems that the size of the mmap area is accumulated
> for rx and tx ring. However, the header status bits are not really interoperable
> with each other. So looks you will need to have two sockets ...